#define SIM
#ifndef SYSTEMC_h
#include "systemc.h"
#endif

#ifndef IDCT_UTIL_H
#include "IDCT_util.h"
#endif

#define W1 2841 /* 2048*sqrt(2)*cos(1*pi/16) */
#define W2 2676 /* 2048*sqrt(2)*cos(2*pi/16) */
#define W3 2408 /* 2048*sqrt(2)*cos(3*pi/16) */
#define W5 1609 /* 2048*sqrt(2)*cos(5*pi/16) */
#define W6 1108 /* 2048*sqrt(2)*cos(6*pi/16) */
#define W7 565  /* 2048*sqrt(2)*cos(7*pi/16) */



SC_MODULE (IDCT){

	 
     sc_in_clk					clock;
     sc_in<bool>				start;		//debut de l'IDCT
     sc_in...				NewBlock;	//debut de l'envoi d'un MB
     ...				din;
     ...				DATA_SENT;	//renvoi des donnees
     ...			dout;
	 	 	
	  Macrobloc	 				blk;

     short iclip[1024]; /* clipping table */
	  short *iclp;

	 	 
	 void idctrow(Macrobloc blk);
	 void idctcol(Macrobloc blk);

	 void Traitement();
	 
	 void Initialize_Fast_IDCT();

	 SC_CTOR(IDCT){
	 		SC_METHOD(....)
			... ;
	
	 		SC_CTHREAD(...,clock.pos());
	 	
		
	}
	
};
	
	
